(define (gcd a b)
  (if (= b 0) a
      (gcd b (remainder a b))))

(define (prim? n)
  (define (smallest-divisor m) (find-divisor m 2))
  (define (find-divisor m test-divisor)
      (cond ((> (square test-divisor) m) m)
            ((divides? test-divisor m) test-divisor)
	    (else (find-divisor m (+ test-divisor 1)))))
  (define (divides? a b) (= (remainder b a) 0))
  (= n (smallest-divisor n)))



(define (expmod base exp m)
  (cond ((= exp 0) 1)
        ((even? exp)
	  (remainder (square (expmod base (/ exp 2) m)) m))
	(else
	  (remainder (* base (expmod base (- exp 1) m)) m))))

(define (fermat-test n)
  (define (try-it a)
    (= (expmod a n n) a))
  (try-it (+ 1 (random (- n 1)))))

(define (prim2 n conf)
  (if (= conf 0)
       #t
       (and (fermat-test n) (prim2 n (- conf 1))))) 
       
